Index: engine/jitc_pinvoke.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc_pinvoke.c,v
retrieving revision 1.3
diff -c -r1.3 jitc_pinvoke.c
*** engine/jitc_pinvoke.c	28 Jul 2006 17:41:54 -0000	1.3
--- engine/jitc_pinvoke.c	16 Sep 2006 13:26:34 -0000
***************
*** 2588,2598 ****
      {
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
  	    {
! 		    MarshalDelegateByRefStruct(function, jit_insn_address_of(function, in), type, jit_insn_address_of(function, in), 0, MARSHAL_ITEM_OF_STRUCTURE, thread);
  		    return;
  	    }
! 	    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
! 	    MarshalDelegateByRefStruct(function, temp, type, temp, 0, MARSHAL_ITEM_OF_STRUCTURE, thread);
  	    return;
      }
      else if(ILTypeIsDelegateSubClass(type))
--- 3080,3089 ----
      {
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
  	    {
! 		    MarshalDelegateByRefStruct(function, jit_insn_address_of(function, in), type, marshalType, jit_insn_address_of(function, in), 0, MARSHAL_ITEM_OF_STRUCTURE);
  		    return;
  	    }
! 	    MarshalDelegateByRefStruct(function, in, type, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  	    return;
      }
      else if(ILTypeIsDelegateSubClass(type))
***************
*** 2601,2685 ****
      }
      else if(ILTypeIsStringClass(type))
      {
! 	    args[0] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)thread);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToAnsi",
! 						    ILStringToAnsi,
! 						    _ILJitSignature_ILStringToAnsi,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToUTF8",
! 						    ILStringToUTF8,
! 						    _ILJitSignature_ILStringToUTF8,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToUTF16",
! 						    ILStringToUTF16,
! 						    _ILJitSignature_ILStringToUTF16,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  	    }
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 		    jit_insn_store_relative(function, in, offset, temp);
! 	    return;
!     }
!     else if(ILType_IsClass(type))
!     {
  	    return;
      }
!     else if(type !=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
  		    case IL_TYPE_COMPLEX_PTR:
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    ILType *elemType = ILType_Ref(type);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    {
  					    MarshalDelegateByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, current,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
! 										    jit_insn_load_relative(function, outAddressValue, offset, _IL_JIT_TYPE_VPTR),
! 										    thread);
  				    }
  				    else MarshalDelegateByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, current,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
! 										    srcArray,
! 										    thread);
  			    }
  			    return;
  		    }
  		    break;
- 		    case IL_TYPE_COMPLEX_PINNED:
- 		    {
- 			    fprintf(stderr, "Marshaling a COMPLEX_PINNED type is not yet supported for marshaling as a return byref value\n");
- 			    return;
- 		    }
- 		    break;
  		    default: break;
  	    }
  
--- 3092,3183 ----
      }
      else if(ILTypeIsStringClass(type))
      {
! 	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
+ 	    char *customName;
+ 	    int customNameLen;
+ 	    char *customCookie;
+ 	    int customCookieLen;
+ 	    ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
+ 	    marshalType = ILPInvokeGetMarshalType
+ 			    (0, method, 0, &customName, &customNameLen, &customCookie, &customCookieLen, type);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToAnsi",
! 							    ILStringToAnsi,
! 							    _ILJitSignature_ILStringToAnsi,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToUTF8",
! 							    ILStringToUTF8,
! 							    _ILJitSignature_ILStringToUTF8,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToUTF16",
! 							    ILStringToUTF16,
! 							    _ILJitSignature_ILStringToUTF16,
! 							    args, 2, JIT_CALL_NOTHROW);
! 			}
! 			break;
! 			default:
! 			{
! 				temp = args[1];
  			}
  			break;
  	    }
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 		    jit_insn_store_relative(function, outAddressValue, offset, temp);
  	    return;
      }
!     else if(type!=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
  		    case IL_TYPE_COMPLEX_PTR:
+ 		    {
+ 			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
+ 				    jit_insn_store_relative(function, in, offset, temp);
+ 			    return;
+ 		    }
+ 		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    ILType *elemType = ILType_Ref(type);
+ 			    elemType = ILTypeGetEnumType(elemType);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    {
  					    MarshalDelegateByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, marshalType,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
! 										    jit_insn_load_relative(function, outAddressValue, offset, _IL_JIT_TYPE_VPTR));
  				    }
  				    else MarshalDelegateByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, marshalType,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
! 										    srcArray);
  			    }
  			    return;
  		    }
  		    break;
  		    default: break;
  	    }
  
***************
*** 2688,2696 ****
  			    srcArray = in;
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
  			    elemType = ILType_ElemType(type);
! 
! 			    if(!NeedMarshalValue(elemType))
  			    {
  				    return;
  			    }
--- 3186,3196 ----
  			    srcArray = in;
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
+ 			    jit_insn_branch_if_not(function, jit_insn_to_bool(function, srcArray),
+ 								&endLoop);
  			    elemType = ILType_ElemType(type);
! 			    elemType = ILTypeGetEnumType(elemType);
! 			    if(!NeedMarshalValue(elemType) || ILType_IsValueType(elemType))
  			    {
  				    return;
  			    }
***************
*** 2711,2728 ****
  										&endLoop);
  			    newElemAddress = jit_insn_dup(function, outAddressValue);
  			    srcElemAddress = jit_insn_add_relative(function, srcArray, (jit_nint)(sizeof(ILUInt32)));
! 			    counter = arraySize;
  			    jit_insn_label(function, &startLoop);
  			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
  		    									jit_value_create_nint_constant(function,
  											_IL_JIT_TYPE_INT32,
  											1)));
  			    MarshalDelegateByRefValue(function, srcElemAddress,
! 							elemType, current,
  							MARSHAL_ITEM_OF_ARRAY,
  							0,
! 							newElemAddress,
! 							thread);
  			    jit_insn_store(function, srcElemAddress,
  							    jit_insn_add(function,
  							    srcElemAddress, srcElemSize));
--- 3211,3227 ----
  										&endLoop);
  			    newElemAddress = jit_insn_dup(function, outAddressValue);
  			    srcElemAddress = jit_insn_add_relative(function, srcArray, (jit_nint)(sizeof(ILUInt32)));
! 			    counter = jit_insn_dup(function, arraySize);
  			    jit_insn_label(function, &startLoop);
  			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
  		    									jit_value_create_nint_constant(function,
  											_IL_JIT_TYPE_INT32,
  											1)));
  			    MarshalDelegateByRefValue(function, srcElemAddress,
! 							elemType, marshalType,
  							MARSHAL_ITEM_OF_ARRAY,
  							0,
! 							newElemAddress);
  			    jit_insn_store(function, srcElemAddress,
  							    jit_insn_add(function,
  							    srcElemAddress, srcElemSize));
***************
*** 2742,2753 ****
  	    }
  
      }
! 
!     // Should not reach here, but make the compiler happy.
      return;
  }
  
! static void MarshalDelegateByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind, ILExecThread *thread)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
      ILField *field = 0;
--- 3241,3252 ----
  	    }
  
      }
!     // If we handled every case above, we should not reach here,
!     // but make the compiler happy.
      return;
  }
  
! static void MarshalDelegateByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
      ILField *field = 0;
***************
*** 2759,2766 ****
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalDelegateByRefValue(function, inAddress, type, 1, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress, thread);
  	    }
      }
      return;
  }
--- 3258,3302 ----
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalDelegateByRefValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  	    }
      }
      return;
  }
+ #endif // USE_BYREF_MARSHALING
+ 
+ /*
+  * Marshal a CLR object to its native representation with custom marshaling support.
+  */
+ static void* MarshalObjectToCustom(void *value, ILType *type, ILMethod *method, ILExecThread *thread)
+ {
+ 	char *customName;
+ 	int customNameLen;
+ 	char *customCookie;
+ 	int customCookieLen;
+ 
+ 	ILPInvokeGetMarshalType
+ 	    (0, method, 0, &customName, &customNameLen,
+ 		&customCookie, &customCookieLen, type);
+ 	void *ptr = _ILObjectToCustom (thread, value, customName, 
+ 					    customNameLen, customCookie, customCookieLen);
+ 	return ptr;
+ }
+ 
+ /*
+  * Marshal a returned native value to a CLR object with custom marshaling support.
+  */
+ static void* MarshalCustomToObject(void *value, ILType *type, ILMethod *method, ILExecThread *thread)
+ {
+ 	char *customName;
+ 	int customNameLen;
+ 	char *customCookie;
+ 	int customCookieLen;
+ 
+ 	ILPInvokeGetMarshalType
+ 	    (0, method, 0, &customName, &customNameLen,
+ 		&customCookie, &customCookieLen, type);
+ 	void *ptr = _ILCustomToObject (thread, value, customName,
+ 					    customNameLen, customCookie, customCookieLen);
+ 	return ptr;
+ }
Index: engine/lib_marshal.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/lib_marshal.c,v
retrieving revision 1.9
diff -c -r1.9 lib_marshal.c
*** engine/lib_marshal.c	22 Jul 2006 08:48:32 -0000	1.9
--- engine/lib_marshal.c	16 Sep 2006 13:26:36 -0000
***************
*** 644,650 ****
  		{
  	    #ifdef IL_USE_JIT
  			*((void **)ptr) = ILJitDelegateGetClosure
! 				(thread, *((ILObject **)ptr), type);
  	    #else
  			*((void **)ptr) = _ILDelegateGetClosure
  				(thread, *((ILObject **)ptr));
--- 644,650 ----
  		{
  	    #ifdef IL_USE_JIT
  			*((void **)ptr) = ILJitDelegateGetClosure
! 				(*((ILObject **)ptr), type);
  	    #else
  			*((void **)ptr) = _ILDelegateGetClosure
  				(thread, *((ILObject **)ptr));
#### End of Patch data ####
